<?php
/**
* @copyright	Copyright (C) 2013 Jsn Project company. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		Easy Profile
* website		www.easy-profile.com
* Technical Support : Forum -	http://www.easy-profile.com/support.html
*/

defined('_JEXEC') or die;

$jsnConfig=JComponentHelper::getParams('com_jsn');
$cluster = $params->def('mapcluster', 0);
$mapstyle = $params->def('mapstyle', "");
$mapstyle_custom = $params->def('mapstyle_custom', "");
$mapdisablescroll = $params->def('mapdisablescroll', 0);

$doc = JFactory::getDocument();
if($jsnConfig->get('bootstrap',0)) {
	$doc->addStylesheet(JURI::root().'media/jui/css/bootstrap.min.css');
	$dir = $doc->direction;
	if($dir=='rtl')
	{
		$doc->addStylesheet(JURI::root().'media/jui/css/bootstrap-rtl.css');
	}
}

$doc->addScript('https://maps.googleapis.com/maps/api/js?libraries=places&key='.$jsnConfig->get('googlemaps_apikey',''));
if($cluster)
	$doc->addScript('https://cdn.rawgit.com/googlemaps/js-marker-clusterer/gh-pages/src/markerclusterer.js');

$map_alias=$params->def('mapfield', false);
$map_lat=$map_alias.'_lat';
$map_lng=$map_alias.'_lng';

$cluster = $params->def('mapcluster', 0) && is_array($list) && count($list)>1;

?>

<?php

$infowindow = function($user,$params,$jsnConfig,$fields_title){
	$return=array();
	$return[]=		'<div class="jsn_listprofile">';
	if($jsnConfig->get('avatar',1))
	{
		$return[]='<div class="listAvatarContainer"><a href="'.$user->getLink().'">';
		$return[]=	$user->getField('avatar_mini');
		$return[]='</a></div>';
	}
	$return[]=	'<div class="listContainer"><div class="listHeaderContainer"><h4>';
	$return[]=		'<a href="'.$user->getLink().'">'.$user->getField('name').'</a>';
	$return[]=	'</h4> ';
	if($jsnConfig->get('status',1))
	{
		$return[]= $user->getField('status');
	}
	$return[]=		'</div><div class="listInfoContainer customfields">';
	$fields=$params->def('list_fields', array());
	if(is_array($fields)) foreach($fields as $field)
	{
		$value=$user->getField($field,true);
		if(!empty($value)){
			$return[]=		'<div class="'.$field.'">';
			if($params->def('show_titles', 0)) $return[]='<span class="listFieldTitle">'.JText::_($fields_title[$field]['title']).': </span>';
			$return[]=		'<span class="listFieldValue">'.$value.'</span></div>';
		}
		
	}
	$return[]=		'</div></div>';
	$return[]=	'</div>';
	$replace_from=array("'","\n","\t");
	$replace_to=array("\'","","");
	return str_replace($replace_from,$replace_to,implode('',$return));
}

?>

<?php if(is_array($list) && count($list) && $map_alias) : ?>
<script>
<?php if($cluster) : ?>
MarkerClusterer.prototype.MARKER_CLUSTER_IMAGE_PATH_ =
    'https://cdn.rawgit.com/googlemaps/js-marker-clusterer/gh-pages/' +
    'images/m';
<?php endif; ?>
function initialize_jsnmap<?php echo $module->id; ?>() {
  var mapOptions = {
    zoom: 4,
    <?php 
    	if($mapdisablescroll) : ?>scrollwheel: false,<?php endif; 
    	if($mapstyle=='light') : ?>styles: [{"featureType":"water","elementType":"geometry","stylers":[{"color":"#e9e9e9"},{"lightness":17}]},{"featureType":"landscape","elementType":"geometry","stylers":[{"color":"#f5f5f5"},{"lightness":20}]},{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#ffffff"},{"lightness":17}]},{"featureType":"road.highway","elementType":"geometry.stroke","stylers":[{"color":"#ffffff"},{"lightness":29},{"weight":0.2}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#ffffff"},{"lightness":18}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#ffffff"},{"lightness":16}]},{"featureType":"poi","elementType":"geometry","stylers":[{"color":"#f5f5f5"},{"lightness":21}]},{"featureType":"poi.park","elementType":"geometry","stylers":[{"color":"#dedede"},{"lightness":21}]},{"elementType":"labels.text.stroke","stylers":[{"visibility":"on"},{"color":"#ffffff"},{"lightness":16}]},{"elementType":"labels.text.fill","stylers":[{"saturation":36},{"color":"#333333"},{"lightness":40}]},{"elementType":"labels.icon","stylers":[{"visibility":"off"}]},{"featureType":"transit","elementType":"geometry","stylers":[{"color":"#f2f2f2"},{"lightness":19}]},{"featureType":"administrative","elementType":"geometry.fill","stylers":[{"color":"#fefefe"},{"lightness":20}]},{"featureType":"administrative","elementType":"geometry.stroke","stylers":[{"color":"#fefefe"},{"lightness":17},{"weight":1.2}]}],<?php endif; 
    	if($mapstyle=='dark') : ?>styles: [{"featureType":"all","elementType":"labels.text.fill","stylers":[{"saturation":36},{"color":"#000000"},{"lightness":40}]},{"featureType":"all","elementType":"labels.text.stroke","stylers":[{"visibility":"on"},{"color":"#000000"},{"lightness":16}]},{"featureType":"all","elementType":"labels.icon","stylers":[{"visibility":"off"}]},{"featureType":"administrative","elementType":"geometry.fill","stylers":[{"color":"#000000"},{"lightness":20}]},{"featureType":"administrative","elementType":"geometry.stroke","stylers":[{"color":"#000000"},{"lightness":17},{"weight":1.2}]},{"featureType":"landscape","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":20}]},{"featureType":"poi","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":21}]},{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#000000"},{"lightness":17}]},{"featureType":"road.highway","elementType":"geometry.stroke","stylers":[{"color":"#000000"},{"lightness":29},{"weight":0.2}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":18}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":16}]},{"featureType":"transit","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":19}]},{"featureType":"water","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":17}]}],<?php endif;
    	if($mapstyle=='custom' && $mapstyle_custom!='') : ?>styles: <?php echo $mapstyle_custom; ?>,<?php endif; ?>
    mapTypeId: google.maps.MapTypeId.ROADMAP
  };

  var jsnmap<?php echo $module->id; ?> = new google.maps.Map(document.getElementById('jsnmap<?php echo $module->id; ?>-canvas'), mapOptions);
  var markers<?php echo $module->id; ?> = [];
  var bounds<?php echo $module->id; ?> = new google.maps.LatLngBounds();
  var size=new google.maps.Size(<?php echo $params->def('mapimagewidth', 25); ?>, <?php echo $params->def('mapimageheight', 25); ?>);

<?php foreach($list as $item) : 
	$user = JsnHelper::getUser($item->id);
	if(isset($user->$map_lat) && $user->$map_lat && isset($user->$map_lng) && $user->$map_lng) :
?>
  var contentString<?php echo $user->id.'_'.$module->id; ?> = '<?php echo $infowindow($user,$params,$jsnConfig,$fields_title); ?>';
  var infowindow<?php echo $user->id.'_'.$module->id; ?> = new google.maps.InfoWindow({
      content: contentString<?php echo $user->id.'_'.$module->id; ?>
  });
  var marker<?php echo $user->id.'_'.$module->id; ?> = new google.maps.Marker({
      position: new google.maps.LatLng(<?php echo $user->$map_lat; ?>,<?php echo $user->$map_lng; ?>),<?php if(!$cluster) : ?>
      map: jsnmap<?php echo $module->id; ?>,<?php endif; ?>
      title: '<?php echo str_replace("'","\'",$user->getField('name')); ?>'<?php if($params->def('mapimage', 'pin')=='avatar') : ?>,
      icon: {
	    url: '<?php echo JURI::root(true).'/'.$user->avatar_mini; ?>',
	    scaledSize: size
	  }<?php endif; ?>
  });
  var prev<?php echo $module->id; ?>=null;
  google.maps.event.addListener(marker<?php echo $user->id.'_'.$module->id; ?>, 'click', function() {
  	if (prev<?php echo $module->id; ?>) {
        prev<?php echo $module->id; ?>.close();
    }
    infowindow<?php echo $user->id.'_'.$module->id; ?>.open(jsnmap<?php echo $module->id; ?>,marker<?php echo $user->id.'_'.$module->id; ?>);
    prev<?php echo $module->id; ?>=infowindow<?php echo $user->id.'_'.$module->id; ?>;
  });
  jQuery('.profile<?php echo substr(md5($user->username),0,10); ?>').mouseover(function(event){
  		google.maps.event.trigger(marker<?php echo $user->id.'_'.$module->id; ?>, 'click' );
  });
  jQuery('.profile<?php echo substr(md5($user->username),0,10); ?>').mouseout(function(event){
  		infowindow<?php echo $user->id.'_'.$module->id; ?>.close();
  });

  bounds<?php echo $module->id; ?>.extend(marker<?php echo $user->id.'_'.$module->id; ?>.getPosition());
  <?php if($cluster) : ?>markers<?php echo $module->id; ?>.push(marker<?php echo $user->id.'_'.$module->id; ?>);<?php endif; ?>

<?php
	endif;
endforeach; 
?>
jsnmap<?php echo $module->id; ?>.fitBounds(bounds<?php echo $module->id; ?>);
<?php if($cluster) : ?>var markerCluster<?php echo $module->id; ?> = new MarkerClusterer(jsnmap<?php echo $module->id; ?>,markers<?php echo $module->id; ?>);<?php endif; ?>
<?php if(count($list)==1) : ?>google.maps.event.addListenerOnce(jsnmap<?php echo $module->id; ?>, 'bounds_changed', function(event) {
        if (jsnmap<?php echo $module->id; ?>.getZoom()){
            jsnmap<?php echo $module->id; ?>.setZoom(17);
        }
 });<?php endif; ?>
}

google.maps.event.addDomListener(window, 'load', initialize_jsnmap<?php echo $module->id; ?>);
</script>
<div id="jsnmap<?php echo $module->id; ?>-canvas" style="height:<?php echo $params->def('mapheight', 400) ?>px;"></div>
<style>
	#jsnmap<?php echo $module->id; ?>-canvas .jsn_listprofile{padding-right:20px;}
</style>
<?php endif; ?>


